// Build.h
//
//////////////////////////////////////////////////////////////////
#ifndef BUILD_H
#define BUILD_H
//////////////////////////////////////////////////////////////////
#include <Math.h>
//////////////////////////////////////////////////////////////////
/* Last Modified: 2003.01.10 */
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
SDL_Color BLACK = {0,0,0, 0};
SDL_Color GRAY = {128,128,128, 0};
SDL_Color DARKGRAY = {64,64,64, 0};
SDL_Color RED = {255,0,0, 0};
SDL_Color BLUE = {0,0,255, 0};
SDL_Color DARKGREEN = {0,128,0, 0};
SDL_Color GREEN = {0,255,0, 0};
SDL_Color YELLOW = {255,255,0, 0};
SDL_Color PURPLE = {255,0,255, 0};
SDL_Color ORANGE = {128,128,0, 0};
SDL_Color WHITE = {255,255,255, 0};

SDL_Color TRANSPARENT = {164,192,234, 0};

const int SECONDS = 1000;

SDL_Rect RCEMPTY = {0,0,0,0};
//////////////////////////////////////////////////////////////////
SDL_Rect newSDL_Rect( int xs,int ys, int dx,int dy ) {
	SDL_Rect rc;
		rc.x = xs; rc.y = ys;
		rc.w = dx; rc.h = dy;
	return( rc );
}
bool IsIn( SDL_Rect &a, SDL_Rect &b ) {
	return( a.x >= b.x && a.y >= b.y && a.x+a.w <= b.x+b.w && a.y+a.h <= b.y+b.h );
}
bool IsIn2( SDL_Rect &a, SDL_Rect &b ) {
	return( a.x >= b.x && a.y >= b.y && a.w <= b.w && a.h <= b.h );
}
bool IsIn2( SDL_Rect &a, SDL_Rect &b, int dx,int dy ) {
/* This guy doesn't really work yet, but it should return okay if
   "a" is within += dx/dy units of "b" */
	if( ( a.x >= b.x && a.y >= b.y && a.w <= b.w && a.h <= b.h ) ||
		( a.x >= b.x-dx && a.y >= b.y && a.w <= b.w+dx && a.h <= b.h ) ||
		//( a.x >= b.x && a.y >= b.y && a.w <= b.w+dx && a.h <= b.h ) ||
		( a.x >= b.x && a.y >= b.y-dy && a.w <= b.w && a.h <= b.h+dy ) ){//||
		//( a.x >= b.x && a.y >= b.y && a.w <= b.w && a.h <= b.h+dy ) ) {
		return( true );
	}
	return( false );
}
/*
	*-----*          *------*       *-------*   *----*       *--*
	|     |  *---*   |    *-+---*   | *---* |   |    |     *-+  +-*
	|     |  |   |   |    |     |   | |   | |   |  *-+-*   | |  | |
	|     |  *---*   |    *-+---*   | *---* |   *--+   |   *-+  +-*
	*-----*          *------*       *-------*      *---*     *--*
	*/
bool RectAtouchesB( SDL_Rect &a, SDL_Rect &b ) {
	if ( (a.y > (b.y+b.h)) ||
		 (a.x > (b.x+b.w)) ||
	     (b.y > (a.y+a.h)) ||
	     (b.x > (a.x+a.w)) ) {
		return(false);
	}
	return(true);//*/
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
/* The following will get the overlap of two rectangles:*/
SDL_Rect GetOverlap( SDL_Rect &a, SDL_Rect &b ) {
	SDL_Rect rcOverlap;
	if( b.y+b.h < a.y ||
		a.y+a.h < b.y ||
		b.x+b.w < a.x ||
		a.x+a.w < b.x ) {
		rcOverlap = newSDL_Rect( -1,-1,0,0 );
	} else {
		rcOverlap.x = (a.x < b.x)?b.x:a.x;
		rcOverlap.y = (a.y < b.y)?b.y:a.y;
		int x2 = (a.x < b.x)?a.x+a.w:b.x+b.w;
		int y2 = (a.y < b.y)?a.y+a.h:b.y+b.h;
		rcOverlap.w = x2-rcOverlap.x;
		rcOverlap.h = y2-rcOverlap.y;
	}
	return(rcOverlap);

}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
SDL_Color newSDL_Color( int r, int g, int b, int a ) {
	SDL_Color clr;
		clr.r = r;
		clr.g = g;
		clr.b = b;
		clr.unused = a;
	return( clr );
}
SDL_Color newSDL_Color( int r, int g, int b ) {
	SDL_Color clr;
		clr.r = r;
		clr.g = g;
		clr.b = b;
		clr.unused = 0;
	return( clr );
}
bool operator==(SDL_Color a, SDL_Color b) {
	return( a.r == b.r && a.g == b.g && a.b == b.b );
}
bool operator!=(SDL_Color a, SDL_Color b) {
	return( ( a.r != b.r || a.g != b.g || a.b != b.b ) );
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
int SDL_MapRGB( SDL_PixelFormat *format, SDL_Color clr ) {
	return( SDL_MapRGB( format, clr.r, clr.g, clr.b ) );
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
int SDL_FillRect( SDL_Surface *dest, SDL_Rect *rc, SDL_Color &clr ) {
	if( dest == NULL ) {  return(-1);  }
	return( SDL_FillRect( dest, rc, SDL_MapRGB( dest->format, clr ) ) );
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
double log( double b, double x ) {
	return( log10(x)/log10(b) );
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
SDL_Surface* CloneBitmap( SDL_Surface* b ) {
	if( b == NULL ) {  return(NULL);  }
	return( SDL_ConvertSurface(b, b->format, b->flags) );



	/*// For this to work, we need to use clean bitmaps (no colorkey, no alpha, etc.)
	// Get the alpha & clear it:
	Uint8 a = b->format->alpha;
	SDL_SetAlpha( b, SDL_SRCALPHA, SDL_ALPHA_OPAQUE ); //255
	// Get the Colorkey & clear it:
	Uint32 clrkey = b->format->colorkey;
	SDL_SetColorKey( b, SDL_SRCCOLORKEY, 0 );

	//SDL_Surface* bmpBmp = SDL_CreateRGBSurface(SDL_SWSURFACE, b->w,b->h, b->format->BitsPerPixel, b->format->Rmask,b->format->Gmask,b->format->Bmask,b->format->Amask );
	SDL_Surface* bmpBmp = SDL_CreateRGBSurface(SDL_SWSURFACE, b->w,b->h, b->format->BitsPerPixel, 0,0,0,0 );
	SDL_BlitSurface( b,NULL, bmpBmp,&(SDL_Rect)newSDL_Rect(0,0, 0,0) );
	SDL_SetColorKey( bmpBmp, SDL_SRCCOLORKEY, clrkey );
	SDL_SetAlpha( bmpBmp, SDL_SRCALPHA, a );

	// Fix up the original:
	SDL_SetAlpha( b, SDL_SRCALPHA, a );
	SDL_SetColorKey( b, SDL_SRCCOLORKEY, clrkey );

	return( bmpBmp );//*/
	
	//SDL_Surface *sReturn;
	/*sReturn = SDL_CreateRGBSurface( SDL_SRCALPHA|SDL_SRCCOLORKEY|SDL_SWSURFACE,
									b->w,b->h,
									b->format->BitsPerPixel,
									b->format->Rmask,
									b->format->Gmask,
									b->format->Bmask,
									b->format->Amask );
	SDL_FillRect( sReturn,NULL, b->format->colorkey );
	SDL_SetColorKey( sReturn, SDL_SRCCOLORKEY, b->format->colorkey );
	SDL_SetAlpha( sReturn, SDL_SRCALPHA, b->format->alpha );
	SDL_BlitSurface( b,NULL, sReturn,&(SDL_Rect)newSDL_Rect(0,0, 0,0) );*/

	//sReturn = SDL_ConvertSurface( b,b->format,b->flags );

	//sReturn = SDL_CreateRGBSurface(SDL_SWSURFACE, b->w,b->h, b->format->BitsPerPixel, 0,0,0,0 );
	//SDL_BlitSurface( b,NULL, sReturn,&(SDL_Rect)newSDL_Rect(0,0, 0,0) );

	//return( sReturn );
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
/*
 * Return the pixel value at (x, y)
 * NOTE: The surface must be locked before calling this!
 */
Uint32 getpixel(SDL_Surface *surface, int x, int y)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to retrieve */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        return *p;

    case 2:
        return *(Uint16 *)p;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
            return p[0] << 16 | p[1] << 8 | p[2];
        else
            return p[0] | p[1] << 8 | p[2] << 16;

    case 4:
        return *(Uint32 *)p;

    default:
        return 0;       /* shouldn't happen, but avoids warnings */
    }
}
/*
 * Set the pixel at (x, y) to the given value
 * NOTE: The surface must be locked before calling this!
 */
void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to set */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        *p = pixel;
        break;

    case 2:
        *(Uint16 *)p = pixel;
        break;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
            p[0] = (pixel >> 16) & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = pixel & 0xff;
        } else {
            p[0] = pixel & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = (pixel >> 16) & 0xff;
        }
        break;

    case 4:
        *(Uint32 *)p = pixel;
        break;
    }
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
bool SpritesOverlap( SDL_Rect *prcOverlap, SDL_Rect &rcA,SDL_Surface *sA, SDL_Rect &rcB,SDL_Surface *sB ) {
	SDL_Rect rcOverlap;
	if( prcOverlap != NULL ) {
		rcOverlap.x = prcOverlap->x;
		rcOverlap.y = prcOverlap->y;
		rcOverlap.w = prcOverlap->w;
		rcOverlap.h = prcOverlap->h;
	} else {
		rcOverlap = GetOverlap( rcA,rcB );
		if( rcOverlap.x == -1 && rcOverlap.y == -1 ) {
			return( false );
		}
	}


	// These rectangles are specific to the SDL_Surfaces (relative to them):
	SDL_Rect rcAO,rcBO;

	rcAO.x = rcOverlap.x-rcA.x;
	rcAO.y = rcOverlap.y-rcA.y;
	rcAO.w = rcOverlap.w;
	rcAO.h = rcOverlap.h;

	rcBO.x = rcOverlap.x-rcB.x;
	rcBO.y = rcOverlap.y-rcB.y;
	rcBO.w = rcOverlap.w;
	rcBO.h = rcOverlap.h;

	if( SDL_MUSTLOCK( sA ) ) {  SDL_LockSurface( sA );  }
	if( SDL_MUSTLOCK( sB ) ) {  SDL_LockSurface( sB );  }
	int pTrans = SDL_MapRGB( sA->format, TRANSPARENT );
	for( int y = 0; y < rcOverlap.h; y++ ) {
		for( int x = 0; x < rcOverlap.w; x++ ) {
			Uint32 pA = getpixel( sA, rcAO.x+x,rcAO.y+y );
			Uint32 pB = getpixel( sB, rcBO.x+x,rcBO.y+y );
			if( pA != pTrans && pB != pTrans ) {
				if( SDL_MUSTLOCK( sA ) ) {  SDL_UnlockSurface( sA );  }
				if( SDL_MUSTLOCK( sB ) ) {  SDL_UnlockSurface( sB );  }
				return( true );
			}
		}
	}
	if( SDL_MUSTLOCK( sA ) ) {  SDL_UnlockSurface( sA );  }
	if( SDL_MUSTLOCK( sB ) ) {  SDL_UnlockSurface( sB );  }
	return( false );
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
String Str( int i ) {
	String str;
	char tmp[12];
		itoa( i,tmp,10 );
	str = tmp;
	return(str);
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
bool StringsAreEqual_IgnoreCase( String &str1, String &str2 ) {
	if( str1.length() != str2.length() ) {
		return( false );
	}
	for( int i = 0; i < str1.length(); i++ ) {
		if( str1[i] == str2[i] ) {
			continue;
		}
		if( str1[i] >= 97 && str1[i] <= 122 ) {
			if( str2[i] == str1[i]-32 ) {
				continue;
			}
		}
		if( str2[i] >= 97 && str2[i] <= 122 ) {
			if( str1[i] == str2[i]-32 ) {
				continue;
			}
		}
		return( false );
	}
	return( true );
}
//////////////////////////////////////////////////////////////////
bool StringsAreEqual_IgnoreCase( String &str1, char *str2 ) {
	return( StringsAreEqual_IgnoreCase( str1, String(str2) ) );
}
bool StringsAreEqual_IgnoreCase( char *str1, String &str2 ) {
	return( StringsAreEqual_IgnoreCase( String(str1), str2 ) );
}
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
#endif
//////////////////////////////////////////////////////////////////