// main.cpp | by Doug Manley
// ...just a medium for PrintStrings().
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
#pragma warning( disable : 4786 )
/* The above warning whines about not being able to write the
   entire name of a something because of vectors being big.  It
   has nothing to with code, just MS's debugger. */
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <string>
#include <vector>

#include <sdl.h>
#include <sdl_ttf.h>
////////////////////////////////////////////////////////////////
typedef std::string String;
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
int WINWIDTH = 640, WINHEIGHT = 480, BPP = 32;
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
#include "Build.h" // helper funtions and such.

#include "PrintStrings.h"
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
int main( int argc, char* argv[] ) {

	// Initialize defaults, Video and Audio:
   if( SDL_Init(SDL_INIT_VIDEO)==(-1) ) { 
      printf("Could not initialize SDL: %s.\n", SDL_GetError());
      exit(-1);
   }

   // Set up the video:
   SDL_Surface *screen;
   screen = SDL_SetVideoMode( WINWIDTH,WINHEIGHT, BPP, SDL_SWSURFACE );
   if( screen == NULL ) {
        fprintf(stderr, "Couldn't set %ix%ix%i video mode: %s\n", WINWIDTH,WINHEIGHT,BPP, SDL_GetError());
        exit(1);
   }
   atexit(SDL_Quit);
   SDL_ShowCursor( SDL_DISABLE ); // The cursor is ugly :)

   // Set up SDL_TTF:
   TTF_Init();
      atexit(TTF_Quit);
   /* TTF_Init() is like SDL_Init(), but with no parameters.
		Basically, it initializes SDL_TTF.  There's really not
		much to it.  Remember, when the program ends, we have
		to call TTF_Quit().  atexit(TTF_Quit) ensures that when
		we call exit(), the program calls TTF_Quit() for us. */



	// Program Meat:
	TTF_Font *fntArial34 = TTF_OpenFont( "Fonts\\Arial.ttf",34 ); // Make a font.
	TTF_Font *fntArial12 = TTF_OpenFont( "Fonts\\Arial.ttf",12 );

	SDL_Surface *sText = NULL;	
	SDL_Rect rcDest = newSDL_Rect(0,0,0,0); // just a filler for this one.
	SDL_Color clrFg = newSDL_Color(255,255,255);
	SDL_Color clrBg = newSDL_Color(0,0,255);
	sText = PrintStrings(NULL,fntArial34,"This is Arial, 34 point.",rcDest,clrFg,clrBg, PS_CREATE_SURFACE );

	// Draw some text in the center:
	rcDest = newSDL_Rect( screen->w/2-sText->w/2,screen->h/2-sText->h/2, 0,0 ); // (center the text)
	SDL_BlitSurface( sText,NULL, screen,&rcDest ); // blit the text in the center.


	// Draw some text somewhere else:
	rcDest = newSDL_Rect( 20,40, 0,0 );
	PrintStrings( screen,fntArial12,"An Arial 12 blit in one line !!",rcDest,clrFg,clrBg,NULL );

	rcDest = newSDL_Rect( 300,400, 0,0 );
	PrintStrings( screen,fntArial12,"An Arial 12 blit, transparent background,\nmultiline...line.",rcDest,clrFg,clrBg,PS_TRANSPARENT_BG );





	SDL_UpdateRect( screen,0,0,0,0 );

	TTF_CloseFont( fntArial34 );



	// Press any key to quit:
	bool quit = false;
	while( !quit ) {
		SDL_Event event;
		if( SDL_PollEvent( &event ) ) {
			switch( event.type ) {
				case SDL_KEYDOWN: {
					quit = true;
					break;
				}
			}
		}
	}



	exit(0); // all done !!
}
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////